@echo off
REM ARKS:       filter.bat by Wes Bishop, 
rem FidoNet 1:133/6021, Internet Wes.Bishop@turner.com
rem SysOp for Hope BBS, 404-453-9671

rem purpose: Uses "Bishop's Filter" (bfilter.exe) to search and replace 
rem          undesirable text strings in fido type message packets.
rem          This procedure is done before mail tosser tosses mail into 
rem          their appropriate conferences on the BBS and just after mail
rem          is received by front end mailer.
rem          This batch also uses Douglas Boling's Strings.com program
rem          which I highly recommend for anyone who writes batch files.

rem ******** check the environment for sufficient space *******************
SET ENVIRTEST=
REM I'm checking for at least 100 bytes of Environment Space:
c:\utils\strings.com envirtest=envfree 
c:\utils\strings.com sub %ENVIRTEST%,100 
if not errorlevel 1 goto GOODENVIR
echo ENVIR SPACE ERROR!
goto EXITERROR
:GOODENVIR
SET ENVIRTEST=

REM Get Day of week for the file extension's first 2 characters
c:\utils\strings.com DAYOFWEEK=day 
c:\utils\strings.com DAYOFWEEK=left %DAYOFWEEK%, 2

REM I first check for zipped pkts in the "In Box" directory:
rem (I'm using Front Door as my mailer in this example)
if not exist c:\fd\file\*.%DAYOFWEEK%? goto CHECKPKT
c:
cd\fd\file

REM Next step is to unzip (unpak) the mail and then delete the zipped files.
c:\utils\pkunzip c:\fd\file\*.%DAYOFWEEK%?
if exist c:\fd\file\*.%DAYOFWEEK%? del c:\fd\file\*.%DAYOFWEEK%?

:PROCESS

REM FILTERING MANIPULATION:
REM **********************
REM NOTE: For this example, I am being very modest with my strings to search:

for %%f in (c:\fd\file\*.pkt) do c:\utils\bfilter %%f "Very Bad Text" /w /q
for %%f in (c:\fd\file\*.pkt) do c:\utils\bfilter %%f "bad word" /r /l /w /q
for %%f in (c:\fd\file\*.pkt) do c:\utils\bfilter %%f "pig" /w /q /r /l

REM continue the above for as many different strings you wish to search for.

REM - A NOTE about the "/L" and "/R" smart switches:
rem Using the above example, when "pig" is found in "piggy" and the /r switch
rem is used, "pig" is ignored and no action is taken. Else, "***gy" occurs.

rem Likewise, when "pig" is found in "spigot" and the /l switch is used,
rem "pig" is ignored and no action is taken. Else, "s***got" occurs.
rem Just remember that "/l" checks for an Alpha to the left of the string and
rem "/r" checks for an Alpha to the right of the string.

rem NOTE: This version of Bishop's Filter is NOT case sensitive.

:END
goto EXIT


REM If no zipped pkts existed, I then check for any received unzipped:
:CHECKPKT
if exist c:\fd\file\*.pkt goto PROCESS
REM At this point, there's nothing to do, so exit.
goto EXIT

:EXITERROR
echo.
echo ERROR!

:EXIT

set DAYOFWEEK= 

REM PLEASE NOTE: The above process works for my set up, but there are no
rem    promises that it will work for yours. I am using Front Door v2.02, 
rem    HyperMail v1.1 and !Wildcat v4.01.
rem    At this writing, I am not checking out going mail, but I am planning
rem    to do so in the near future.

